    #Imports:
import random
import time
import pygame
from PIL import Image


        #Variables utiles pour le futur:
level=None

#Variables Constantes:
run = True
resolution=30 #Resolution c'est juste la hauteur et largeur en pixels de chaque pièce du jeu.


#Refresh Rate:
fps=30
clock = pygame.time.Clock()


#Fonts du texte:
pygame.font.init()
bfont = pygame.font.Font("Images/font.TTF", 105) #biggest font
mfont = pygame.font.Font("Images/font.TTF", 70) #medium font
msfont = pygame.font.Font("Images/font.TTF", 50) #medium small font 
sfont = pygame.font.Font("Images/font.TTF", 30) #small font

    #Musique:
pygame.mixer.init()
pygame.mixer.music.set_volume(0.1)
#sfx:
death_sfx=pygame.mixer.Sound(file="Sounds/game_over.wav")
pygame.mixer.Sound.set_volume(death_sfx,2.0)

success_sfx=pygame.mixer.Sound(file="Sounds/Success.ogg")
pygame.mixer.Sound.set_volume(success_sfx,2.0)

mouvement_sfx=pygame.mixer.Sound(file="Sounds/jump.wav")
pygame.mixer.Sound.set_volume(mouvement_sfx,0.5)

hover_sfx=pygame.mixer.Sound(file="Sounds/Hover.wav")
pygame.mixer.Sound.set_volume(hover_sfx,0.8)

selection_sfx=pygame.mixer.Sound(file="Sounds/Selection.wav")
pygame.mixer.Sound.set_volume(selection_sfx,0.8)



                #Couleurs
BLACK = "#000000"
WHITE = "#FFFFFF"
GREY = (200, 200, 200)
RED = "#FF0000"
GREEN= "#00FF00"
BLUE= "#0000FF"
YELLOW= "#FFFF00"
PURPLE="#E6E6FA"
LIGHTBLUE = "#B7F9FF" 
LIGHTPINK = "#FFBDB7"
WHITEBLUE = "#DCFCFF"
couleurs=[BLACK,WHITE,GREY,RED,GREEN,BLUE,YELLOW,PURPLE,LIGHTBLUE,LIGHTPINK,WHITEBLUE]

BACKGROUND_COLOR=BLACK
WALL_COLOR=WHITE
SPIKE_COLOR=RED
ENEMY_COLOR=BLUE


#Random small functions
def draw_rectangle(x, y, Width, Height, couleur):
    """Args:
    x (int): x position of the upper-left corner of the rectangle
    y (int): y position of the upper-left corner of the rectangle
    Width (int): Width of the rectangle
    Height (int): Height of the rectangle
    couleur (tuple): Color of the rectangle"""
    return pygame.draw.rect(screen,couleur,pygame.Rect(x,y,Width,Height))

def draw_circle(x, y, couleur, rayon):
    """Args:
    x_rect (int): x position of the center of the circle
    y_rect (int): y position of the center of the circle
    couleur (tuple): Color of the rectangle
    rayon (int): diameter of the circle/2 (I forgot the word for it)"""
    return pygame.draw.circle(screen, couleur, [x, y], rayon)

def randcol():
    return (random.randint(0,255),random.randint(0,255),random.randint(0,255))



def coord_find(obj, zone): #Rencontrer le joueur
    """Finds the coords of a given object in a maze array (only the first found)

    Args:
        obj (any): what to find
        zone (array): where to find

    Returns:
        tuple: (x coord, y coord)
    """
    for i in range(len(zone)):
        if obj in zone[i]:
            y_P=i
            x_P=zone[i].index(obj)
            break
    return (x_P, y_P)
    #type:


def GAME_OVER():
    death_sfx.play()
    
    game_over_txt=msfont.render("GAME OVER", True, RED)
    game_over_txt=pygame.transform.scale(game_over_txt,(700,200))
    screen.blit(game_over_txt,(W/2-350,H/2-125))
    
    clock.tick(fps)
    pygame.display.update()
    time.sleep(2)
    main_menu()

def SUCCESS():
    success_sfx.play()
    
    game_over_txt=msfont.render("Well Done!", True, YELLOW)
    game_over_txt=pygame.transform.scale(game_over_txt,(700,200))
    screen.blit(game_over_txt,(W/2-350,H/2-125))
    
    clock.tick(fps)
    pygame.display.update()
    time.sleep(2)
    Next_Level()
def Next_Level():
    global level
    if level==maze_array_1:
        level=maze_array_2
    elif level==maze_array_2:
        level=maze_array_3
    elif level==maze_array_3:
        level=maze_array_4
    elif level==maze_array_4:
        level=maze_array_5
    elif level==maze_array_5:
        
        end_text=msfont.render("New Levels Soon!", True, BLACK)
        end_text=pygame.transform.scale(end_text,(700,300))
        
        screen.fill(WHITE)
        screen.blit(end_text,(W/2-350,H/2-150))
        pygame.display.update()
        
        WIN=True
        while WIN:
            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    pygame.quit()
                
                elif event.type == pygame.MOUSEBUTTONDOWN:
                    WIN=False
        
        main_menu()


def change_music(level):
    pygame.mixer.music.stop()
    if level==maze_array_1:
        pygame.mixer.music.load("Sounds/Music/Run-Amok.ogg")
        pygame.mixer.music.play(loops=100)
    elif level==maze_array_2:
        pygame.mixer.music.load("Sounds/Music/Komiku_-_04_-_Skate.ogg")
        pygame.mixer.music.play(loops=100)
    elif level==maze_array_3:
        pygame.mixer.music.load("Sounds/Music/Run-Amok.ogg")
        pygame.mixer.music.play(loops=100)
    elif level==maze_array_4:
        pygame.mixer.music.load("Sounds/Music/Cipher2.ogg")
        pygame.mixer.music.play(loops=100)
    else:
        pygame.mixer.music.load("Sounds/Music/Samurai-Sake-Showdown.ogg")
        pygame.mixer.music.play(loops=100)
def rand_music(musics=["Komiku_-_04_-_Skate.ogg",
                       "Run-Amok.ogg",
                       "Cipher2.ogg",
                       "Samurai-Sake-Showdown.ogg",
                       "Fluffing-a-Duck.ogg",
                       "Monkeys-Spinning-Monkeys.ogg",
                       "Sneaky-Snitch.ogg",
                       "Space-Jazz.ogg",
                       "menu.wav"]):
    return "Sounds/Music/"+random.choice(musics)






#Fonctions Labyrinthe:
    
def maze_processor(image): #Processeur d'images en labyrinthes:
    """Turns a tiny image of a handmade pixelated maze into a maze array
    '#FFFFFF'(white)==wall; '#000000'(black)==null; '#A1A1A1'(grey)==player location; '#FF0000'(red)==spike; '#0000FF'(blue)==ennemy
    
    Args:
        image (str): file name/location
        res (int): width in pixels of the file
    """
    img=Image.open(image,"r")
    res=img.size[0]
    pixels = list(img.getdata())
    maze=[[]]
    x=0
    y=0
    for i in pixels:
        if x>=res:
            x=0
            y+=1
            maze.append([])
        
        if i[0]==0 and i[1]==0 and i[2]==0:
            maze[y].append(0)
        elif i[0]==255 and i[1]==255 and i[2]==255:
            maze[y].append(1)
        elif i[0]==161 and i[1]==161 and i[2]==161:
            maze[y].append("P")
        elif i[0]==255 and i[1]==0 and i[2]==0:
            maze[y].append(2)
        elif i[0]==0 and i[1]==0 and i[2]==255:
            maze[y].append(3)
        elif i[0]==255 and i[1]==255 and i[2]==0:
            maze[y].append(9)
        else:
            maze[y].append("ERROR")
        x+=1
            
    return maze

maze_array_1=maze_processor("Images/Levels/maze-1.png")
maze_array_2=maze_processor("Images/Levels/maze-2.png")
maze_array_3=maze_processor("Images/Levels/maze-3.png")
maze_array_4=maze_processor("Images/Levels/maze-4.png")
maze_array_5=maze_processor("Images/Levels/maze-5.png")

def maze_printer(maze): #Accepte un maze_array et l'affiche à l'utilisateur
    """Takes in a list of lists as a maze
    Caption: 1=wall; 0=null; "P"=Player; 2=spike; 3=ennemy(abeille); 4=ennemy(skull); 9=objectif
    Args:
        maze (list): list array
    """
    x=0
    y=0
    for line_index, line in enumerate(maze):
        for column_index, column in enumerate(line):
            if column==1:
                if line_index==0:
                    screen.blit(bamboo_top, (x,y))
                elif maze[line_index-1][column_index]==1 or maze[line_index-1][column_index]==2 or maze[line_index-1][column_index]==9:
                    screen.blit(bamboo_wall, (x,y))
                else:
                    screen.blit(bamboo_top, (x,y))
                x+=resolution
            elif column==2:
                screen.blit(image_spike,(x,y))
                x+=resolution
            elif column==0:
                x+=resolution
            elif column==3:
                screen.blit(image_abeille,(x,y))
                x+=resolution
            elif column==4:
                screen.blit(image_skull,(x,y))
                x+=resolution
            elif column=="P":
                screen.blit(image_joueur, (x, y))
                x+=resolution
            elif column==9:
                screen.blit(finish_line, (x, y))
                x+=resolution
            else:
                draw_rectangle(x,y,resolution,resolution, RED)
                x+=resolution
        y+=resolution
        x=0
    
    global finish_state
    if finish_state<2:
        finish_state+=0.1
    else:
        finish_state=0
    finish_animate(finish_state)
    
    global level
    level=movement_entities(level)




#Joueur
image_joueur=pygame.image.load('Images/Pixel_art/panda_pixil.png')
image_joueur=pygame.transform.scale(image_joueur,(resolution,resolution))

#Ennemi (abeille)
image_abeille=pygame.image.load('Images/Pixel_art/bee.png')
image_abeille=pygame.transform.scale(image_abeille,(resolution,resolution))

#Ennemi (skull)
image_skull=pygame.image.load('Images/Pixel_art/skull.png')
image_skull=pygame.transform.scale(image_skull,(resolution,resolution))

#Piège
image_spike=pygame.image.load('Images/Pixel_art/Trap_Open.png')
image_spike=pygame.transform.scale(image_spike,(resolution,resolution))

#Bamboo walls
bamboo_wall=pygame.image.load('Images/Pixel_art/Bamboo_wall(continuous).png')
bamboo_wall=pygame.transform.scale(bamboo_wall,(resolution,resolution))
bamboo_top=pygame.image.load('Images/Pixel_art/Bamboo_wall.png')
bamboo_top=pygame.transform.scale(bamboo_top,(resolution,resolution))

#Ligne d'arrivée:
finish_line=pygame.image.load('Images/Pixel_art/Finish_Circle.png')
finish_line=pygame.transform.scale(finish_line,(resolution,resolution))
def finish_animate(n):
    global finish_line
    if int(n)==1 or int(n)==2:
        finish_line=pygame.image.load('Images/Pixel_art/Finish_Oval.png')
        finish_line=pygame.transform.scale(finish_line,(resolution,resolution))
    else:
        finish_line=pygame.image.load('Images/Pixel_art/Finish_Circle.png')
        finish_line=pygame.transform.scale(finish_line,(resolution,resolution))
finish_state=0        


# Initialisation de l´écran
width=25
height=25
W, H=width*resolution, height*resolution 
size=(W, H)
screen=pygame.display.set_mode(size)
pygame.display.set_caption("Panda's Nighttime invasion")





def movement(game, direction): #Mouvements du joueur (dans la maze array)
    """Takes care of the movement of the character.

    Args:
        game (maze array): maze array in which the character will move (and already exists)
        direction (str): Can be "UP", "LEFT", "RIGHT", "DOWN"
    """
    x_P=coord_find("P", game)[0]
    y_P=coord_find("P", game)[1]
    
    
    if direction=="UP" and y_P>0:
        if game[y_P-1][x_P]==0:
            mouvement_sfx.play()
        while game[y_P-1][x_P]==0:
            y_P-=1
            game[y_P+1][x_P],game[y_P][x_P]=game[y_P][x_P],game[y_P+1][x_P]
            
            time.sleep(.01)
            screen.fill(BACKGROUND_COLOR)
            maze_printer(game)
            clock.tick(fps)
            pygame.display.update()
            
            if y_P==0:
                break
        if game[y_P-1][x_P]==9:
            SUCCESS()
            change_music(level)
            return level
        if game[y_P-1][x_P]==2 or game[y_P-1][x_P]==3 or game[y_P-1][x_P]==4:
            GAME_OVER()
            change_music(level)
            return level
            
       
    elif direction=="DOWN" and y_P<height-1:
        if game[y_P+1][x_P]==0:
            mouvement_sfx.play()
        while game[y_P+1][x_P]==0:
            y_P+=1
            game[y_P-1][x_P],game[y_P][x_P]=game[y_P][x_P],game[y_P-1][x_P]
            
            time.sleep(.01)
            screen.fill(BACKGROUND_COLOR)
            maze_printer(game)
            clock.tick(fps)
            pygame.display.update()
            
            if y_P==height-1:
                break
        if game[y_P+1][x_P]==9:
            SUCCESS()
            change_music(level)
            return level
        elif game[y_P+1][x_P]==2 or game[y_P+1][x_P]==3 or game[y_P+1][x_P]==4:
            GAME_OVER()
            change_music(level)
            return level
                
    elif direction=="LEFT" and x_P>0:
        if game[y_P][x_P-1]==0:
            mouvement_sfx.play()
        while game[y_P][x_P-1]==0:
            x_P-=1
            game[y_P][x_P+1],game[y_P][x_P]=game[y_P][x_P],game[y_P][x_P+1]
            
            time.sleep(.01)
            screen.fill(BACKGROUND_COLOR)
            maze_printer(game)
            clock.tick(fps)
            pygame.display.update()
            
            if x_P==0:
                break
        if game[y_P][x_P-1]==9:
            SUCCESS()
            change_music(level)
            return level
        elif game[y_P][x_P-1]==2 or game[y_P][x_P-1]==3 or game[y_P][x_P-1]==4:
            GAME_OVER()
            change_music(level)
            return level
            
    elif direction=="RIGHT" and x_P<width-1:
        if game[y_P][x_P+1]==0:
            mouvement_sfx.play()
        while game[y_P][x_P+1]==0:
            x_P+=1
            game[y_P][x_P-1],game[y_P][x_P]=game[y_P][x_P],game[y_P][x_P-1]
            
            time.sleep(.01)
            screen.fill(BACKGROUND_COLOR)
            maze_printer(game)
            clock.tick(fps)
            pygame.display.update()
            
            if x_P==width-1:
                break
        if game[y_P][x_P+1]==9:
            SUCCESS()
            change_music(level)
            return level
        elif game[y_P][x_P+1]==2 or game[y_P][x_P+1]==3 or game[y_P][x_P+1]==4:
            GAME_OVER()
            change_music(level)
            return level
    
    return game

def movement_entities(game):
    """"Takes care of the behaviour of entities all around the level, except the player and the spikes

    Args:
        game (array): the array of the level
    """
    
    #Stockage des localisations des entités:
    abeilles=[]
    skulls=[]
    
    
    #Recherche de la localisation des ennemis:
    for line_index, line in enumerate(game):
        for j in line:
            if j==3:#abeille
                abeilles.append((j,line_index))
            elif j==4: #skull
                skulls.append((j,line_index))
    
        #Mouvements:
    #des abeilles:
    for abeille in abeilles:
        x=abeille[0]
        print(x)
        y=abeille[1]
        print(y)
        if game[y][x+1]==0 or game[y][x+1]=="P":
            game[y][x+1],game[y][x]=game[y][x],game[y][x+1]
    return game
    


#Menus
def niveaux(): #ecran niveaux (à complèter)
    niv = True
    global level
    while niv:
        screen.fill(BLACK)

        niv_txt = bfont.render("NIVEAUX",True , LIGHTPINK)
        screen.blit(niv_txt,(180,120))

        retour_rect = pygame.draw.rect(screen, BLACK, (60,60,95,20), 3)
        retour_txt = sfont.render("RETOUR", True, LIGHTPINK)
        screen.blit(retour_txt,(60,60)) 

        #Boutons pour niveaux:
        niv1_rect = pygame.draw.rect(screen, LIGHTPINK, (20,320,100,100), 3)
        niv1_txt = mfont.render("1",True ,LIGHTPINK)
        screen.blit(niv1_txt,(55,345))

        niv2_rect = pygame.draw.rect(screen, LIGHTPINK, (170,320,100,100), 3)
        niv2_txt = mfont.render("2",True ,LIGHTPINK)
        screen.blit(niv2_txt,(205,345))

        niv3_rect = pygame.draw.rect(screen, LIGHTPINK, (320,320,100,100), 3)
        niv3_txt = mfont.render("3",True ,LIGHTPINK)
        screen.blit(niv3_txt,(355,345))

        niv4_rect = pygame.draw.rect(screen, LIGHTPINK, (470,320,100,100), 3)
        niv4_txt = mfont.render("4",True ,LIGHTPINK)
        screen.blit(niv4_txt,(505,345))

        niv5_rect = pygame.draw.rect(screen, LIGHTPINK, (620,320,100,100), 3)
        niv5_txt = mfont.render("5",True ,LIGHTPINK)
        screen.blit(niv5_txt,(655,345))

        # Réactions des boutons (À compléter)
        if retour_rect.collidepoint(pygame.mouse.get_pos()):
            retour_txt = sfont.render("RETOUR", True, LIGHTBLUE)
            screen.blit(retour_txt,(60,60))

        if niv1_rect.collidepoint(pygame.mouse.get_pos()):
            niv1_rect = pygame.draw.rect(screen, LIGHTBLUE, (20,320,100,100), 3)
            niv1_txt = mfont.render("1",True ,LIGHTBLUE)
            screen.blit(niv1_txt,(55,345))

        if niv2_rect.collidepoint(pygame.mouse.get_pos()):
            niv2_rect = pygame.draw.rect(screen, LIGHTBLUE, (170,320,100,100), 3)
            niv2_txt = mfont.render("2",True ,LIGHTBLUE)
            screen.blit(niv2_txt,(205,345))

        if niv3_rect.collidepoint(pygame.mouse.get_pos()):
            niv3_rect = pygame.draw.rect(screen, LIGHTBLUE, (320,320,100,100), 3)
            niv3_txt = mfont.render("3",True ,LIGHTBLUE)
            screen.blit(niv3_txt,(355,345))

        if niv4_rect.collidepoint(pygame.mouse.get_pos()):
            niv4_rect = pygame.draw.rect(screen, LIGHTBLUE, (470,320,100,100), 3)
            niv4_txt = mfont.render("4",True ,LIGHTBLUE)
            screen.blit(niv4_txt,(505,345))

        if niv5_rect.collidepoint(pygame.mouse.get_pos()):
            niv5_rect = pygame.draw.rect(screen, LIGHTBLUE, (620,320,100,100), 3)
            niv5_txt = mfont.render("5",True ,LIGHTBLUE)
            screen.blit(niv5_txt,(655,345))

        for event in pygame.event.get():
            if event.type == pygame.MOUSEBUTTONDOWN:
                #Retour:
                if retour_rect.collidepoint(pygame.mouse.get_pos()):
                    selection_sfx.play()
                    level=None
                    niv=False
                #Niveaux:
                elif niv1_rect.collidepoint(pygame.mouse.get_pos()):
                    selection_sfx.play()
                    
                    level=maze_array_1
                    niv=False
                elif niv2_rect.collidepoint(pygame.mouse.get_pos()):
                    selection_sfx.play()

                    level=maze_array_2
                    niv=False
                elif niv3_rect.collidepoint(pygame.mouse.get_pos()):
                    selection_sfx.play()
                   
                    level=maze_array_3
                    niv=False
                elif niv4_rect.collidepoint(pygame.mouse.get_pos()):
                    selection_sfx.play()
                    
                    level=maze_array_4
                    niv=False
                elif niv5_rect.collidepoint(pygame.mouse.get_pos()):
                    selection_sfx.play()
                    
                    level=maze_array_5
                    niv=False
                
            elif event.type == pygame.QUIT:
                pygame.quit()
            
        pygame.display.update()

def options(): # options de son menu principal
    #variables pour l'affichage du niveau du volume
    volume_principal = 100 #volume principal
    effets_sonores = 100 #effets sonores
    musique = 100 #musique
    #variables pour le niveau du volume
    #effets sonores
    a = 1.0
    b = 1.0
    c = 1.0
    d = 0.8
    e = 1.0
    
    #musique
    f = 0.1

    options = True
    while options:
        #affichage
        screen.fill(BLACK)

        niv_txt = bfont.render("OPTIONS", True, LIGHTPINK)
        screen.blit(niv_txt,(180,90))

        vol_txt = msfont.render("VOLUME PRINCIPAL:",True ,LIGHTBLUE)
        screen.blit(vol_txt,(160,200))

        volplus_rect = pygame.draw.rect(screen, LIGHTBLUE, (455,255,70,70), 3)
        volplus_txt = mfont.render("+",True ,LIGHTBLUE)
        screen.blit(volplus_txt,(478,262))

        volmoins_rect = pygame.draw.rect(screen, LIGHTBLUE, (205,255,70,70), 3)
        volmoins_txt = mfont.render("-",True ,LIGHTBLUE)
        screen.blit(volmoins_txt,(230,262)) 

        es_txt = msfont.render("EFFETS SONORES:",True ,LIGHTBLUE)
        screen.blit(es_txt,(170,350))

        esplus_rect = pygame.draw.rect(screen, LIGHTBLUE, (455,405,70,70), 3)
        esplus_txt = mfont.render("+",True ,LIGHTBLUE)
        screen.blit(esplus_txt,(478,412))

        esmoins_rect = pygame.draw.rect(screen, LIGHTBLUE, (205,405,70,70), 3)
        esmoins_txt = mfont.render("-",True ,LIGHTBLUE)
        screen.blit(esmoins_txt,(230,412)) 

        mus_txt = msfont.render("MUSIQUE:",True ,LIGHTBLUE)
        screen.blit(mus_txt,(260,500))

        musplus_rect = pygame.draw.rect(screen, LIGHTBLUE, (455,555,70,70), 3)
        musplus_txt = mfont.render("+",True ,LIGHTBLUE)
        screen.blit(musplus_txt,(478,562))

        musmoins_rect = pygame.draw.rect(screen, LIGHTBLUE, (205,555,70,70), 3)
        musmoins_txt = mfont.render("-",True ,LIGHTBLUE)
        screen.blit(musmoins_txt,(230,562)) 

        retour_rect = pygame.draw.rect(screen, BLACK, (60,60,95,20), 3)
        retour_txt = sfont.render("RETOUR", True, LIGHTPINK)
        screen.blit(retour_txt,(60,60)) 
        
        #quand la souris passe au-dessus des 'boutons' + et -
        if retour_rect.collidepoint(pygame.mouse.get_pos()):
            retour_txt = sfont.render("RETOUR", True, LIGHTBLUE)
            screen.blit(retour_txt,(60,60))
        
        if volplus_rect.collidepoint(pygame.mouse.get_pos()):
            volplus_rect = pygame.draw.rect(screen, LIGHTPINK, (455,255,70,70), 3)
            volplus_txt = mfont.render("+", True, LIGHTPINK)
            screen.blit(volplus_txt,(478,262))
        
        if volmoins_rect.collidepoint(pygame.mouse.get_pos()):
            volmoins_rect = pygame.draw.rect(screen, LIGHTPINK, (205,255,70,70), 3)
            volmoins_txt = mfont.render("-", True, LIGHTPINK)
            screen.blit(volmoins_txt,(230,262))

        if esplus_rect.collidepoint(pygame.mouse.get_pos()):
            esplus_rect = pygame.draw.rect(screen, LIGHTPINK, (455,405,70,70), 3)
            esplus_txt = mfont.render("+",True ,LIGHTPINK)
            screen.blit(esplus_txt,(478,412))
        
        if esmoins_rect.collidepoint(pygame.mouse.get_pos()):
            esmoins_rect = pygame.draw.rect(screen, LIGHTPINK, (205,405,70,70), 3)
            esmoins_txt = mfont.render("-",True ,LIGHTPINK)
            screen.blit(esmoins_txt,(230,412)) 
        
        if musplus_rect.collidepoint(pygame.mouse.get_pos()):
            musplus_rect = pygame.draw.rect(screen, LIGHTPINK, (455,555,70,70), 3)
            musplus_txt = mfont.render("+",True ,LIGHTPINK)
            screen.blit(musplus_txt,(478,562))
        
        if musmoins_rect.collidepoint(pygame.mouse.get_pos()):
            musmoins_rect = pygame.draw.rect(screen, LIGHTPINK, (205,555,70,70), 3)
            musmoins_txt = mfont.render("-",True ,LIGHTPINK)
            screen.blit(musmoins_txt,(230,562))

        #quand le joueur appuie sur les 'boutons' + et -
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
            elif event.type == pygame.MOUSEBUTTONDOWN:
                #Retour
                
                if retour_rect.collidepoint(pygame.mouse.get_pos()):
                    selection_sfx.play()
                    options=False
                if volplus_rect.collidepoint(pygame.mouse.get_pos()):
                    selection_sfx.play()
                    if volume_principal <= 95:
                        volume_principal += 5
                    if effets_sonores <= 95:
                        effets_sonores += 5
                    if musique <= 95:
                        musique += 5
                    if a <= 0.95:
                        a += 0.05
                    if b <= 0.95:
                        b += 0.05
                    if c <= 0.95:
                        c += 0.05
                    if d <= 0.76:
                        d += 0.04
                    if f <= 0.095:
                        f += 0.005
                if volmoins_rect.collidepoint(pygame.mouse.get_pos()):
                    selection_sfx.play()
                    if volume_principal >= 5:
                        volume_principal -= 5
                    if effets_sonores >= 5:
                        effets_sonores -= 5
                    if musique >= 5:
                        musique -= 5
                    if a >= 0.049:
                        a -= 0.05
                    if b >= 0.049:
                        b -= 0.05
                    if c >= 0.049:
                        c -= 0.05
                    if d >= 0.039:
                        d -= 0.04
                    if f >= 0.0049:
                        f -= 0.005
                if esplus_rect.collidepoint(pygame.mouse.get_pos()):
                    selection_sfx.play()
                    if effets_sonores <= 95:
                        effets_sonores += 5
                    if a <= 0.95:
                        a += 0.05
                    if b <= 0.95:
                        b += 0.05
                    if c <= 0.95:
                        c += 0.05
                    if d <= 0.76:
                        d += 0.04
                if esmoins_rect.collidepoint(pygame.mouse.get_pos()):
                    selection_sfx.play()
                    if effets_sonores >= 5:
                        effets_sonores -= 5
                    if a >= 0.049:
                        a -= 0.05
                    if b >= 0.049:
                        b -= 0.05
                    if c >= 0.049:
                        c -= 0.05
                    if d >= 0.039:
                        d -= 0.04
                if musplus_rect.collidepoint(pygame.mouse.get_pos()) and musique <= 95 and f <= 0.095:
                    selection_sfx.play()
                    musique += 5
                    f += 0.005 
                if musmoins_rect.collidepoint(pygame.mouse.get_pos()) and musique >= 5 and f >= 0.0049:
                    selection_sfx.play()
                    musique -= 5
                    f -= 0.005 
        
            
        death_sfx.set_volume(a)
        mouvement_sfx.set_volume(b)
        hover_sfx.set_volume(c)
        selection_sfx.set_volume(d)
        success_sfx.set_volume(e)
        pygame.mixer.music.set_volume(f) 

        nivvol_txt = msfont.render(str(volume_principal),True,LIGHTBLUE) 
        screen.blit(nivvol_txt,(328,270))

        nives_txt = msfont.render(str(effets_sonores),True,LIGHTBLUE) 
        screen.blit(nives_txt,(328,420))

        nivmus_txt = msfont.render(str(musique),True,LIGHTBLUE) 
        screen.blit(nivmus_txt,(328,570))
        pygame.display.update()

def main_menu(): #ecran main menu
    main=True
    global level
    #Réinitialisation des niveaux etc...
    initiate()
    
    #Musique random de menu:
    pygame.mixer.music.stop()
    pygame.mixer.music.load(rand_music(["Fluffing-a-Duck.ogg",
                                        "Monkeys-Spinning-Monkeys.ogg",
                                        "menu.wav",
                                        "Sneaky-Snitch.ogg",
                                        "Space-Jazz.ogg"]))
    pygame.mixer.music.play(loops=10)
    
    while main:
        screen.fill(BLACK)

        #Textes:
        menu_txt = msfont.render("PANDA'S NIGHTTIME INVASION",True , WHITEBLUE)
        screen.blit(menu_txt,(45,90))
    
        niv_rect = pygame.draw.rect(screen, LIGHTBLUE, (160,185,420,100), 3)
        niv_txt = mfont.render("JOUER",True ,LIGHTBLUE)
        screen.blit(niv_txt,(270,210))
        
        op_rect = pygame.draw.rect(screen, LIGHTBLUE, (160,335,420,100), 3)
        op_txt = mfont.render("OPTIONS",True ,LIGHTBLUE)
        screen.blit(op_txt,(245,360))
        
        quit_rect = pygame.draw.rect(screen, LIGHTBLUE, (160,485,420,100), 3)
        quit_txt = mfont.render("QUITTER",True ,LIGHTBLUE)
        screen.blit(quit_txt,(245,510))

        #Hover effects:
        if niv_rect.collidepoint(pygame.mouse.get_pos()):
            #hover_sfx.play()
            niv_rect = pygame.draw.rect(screen, LIGHTPINK, (160,185,420,100), 3)
            niv_txt = mfont.render("JOUER",True ,LIGHTPINK)
            screen.blit(niv_txt,(270,210))
            

        elif op_rect.collidepoint(pygame.mouse.get_pos()):
            #hover_sfx.play()
            op_rect = pygame.draw.rect(screen, LIGHTPINK, (160,335,420,100), 3)
            op_txt = mfont.render("OPTIONS",True ,LIGHTPINK)
            screen.blit(op_txt,(245,360))
            
        elif quit_rect.collidepoint(pygame.mouse.get_pos()):
            #hover_sfx.play()
            quit_rect = pygame.draw.rect(screen, LIGHTPINK, (160,485,420,100), 3)
            quit_txt = mfont.render("QUITTER",True ,LIGHTPINK )
            screen.blit(quit_txt,(245,510))
         
        #Clicks:    
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                
            elif event.type == pygame.MOUSEBUTTONDOWN:
                
                if niv_rect.collidepoint(pygame.mouse.get_pos()):
                    selection_sfx.play()
                    
                    niveaux()
                    if level!=None:
                        main=False
                
                elif op_rect.collidepoint(pygame.mouse.get_pos()):
                    selection_sfx.play()
                    options()
                
                elif quit_rect.collidepoint(pygame.mouse.get_pos()):
                    selection_sfx.play()
                    pygame.quit()
        
        pygame.display.update()

def initiate(): #Réinitie la plupart des variables utilisées au cours de tout le programme à son état initial
        #Niveaux:
    global maze_array_1, maze_array_2, maze_array_3, maze_array_4, maze_array_5
    maze_array_1=maze_processor("Images/Levels/maze-1.png")
    maze_array_2=maze_processor("Images/Levels/maze-2.png")
    maze_array_3=maze_processor("Images/Levels/maze-3.png")
    maze_array_4=maze_processor("Images/Levels/maze-4.png")
    maze_array_5=maze_processor("Images/Levels/maze-5.png")
    global level
    level=None
    
        #Images:
    global image_joueur,image_ennemi, image_spike, bamboo_wall, bamboo_top, finish_line
    #Joueur
    image_joueur=pygame.image.load('Images/Pixel_art/panda_pixil.png')
    image_joueur=pygame.transform.scale(image_joueur,(resolution,resolution))

    #Ennemi
    image_ennemi=pygame.image.load('Images/Pixel_art/skull.png')
    image_ennemi=pygame.transform.scale(image_ennemi,(resolution,resolution))

    #Piège
    image_spike=pygame.image.load('Images/Pixel_art/Trap_Open.png')
    image_spike=pygame.transform.scale(image_spike,(resolution,resolution))

    #Bamboo walls
    bamboo_wall=pygame.image.load('Images/Pixel_art/Bamboo_wall(continuous).png')
    bamboo_wall=pygame.transform.scale(bamboo_wall,(resolution,resolution))
    bamboo_top=pygame.image.load('Images/Pixel_art/Bamboo_wall.png')
    bamboo_top=pygame.transform.scale(bamboo_top,(resolution,resolution))

    #Ligne d'arrivée:
    finish_line=pygame.image.load('Images/Pixel_art/Finish_Circle.png')
    finish_line=pygame.transform.scale(finish_line,(resolution,resolution))


main_menu()
change_music(level)

def esc_menu(): #Menu d'échappe:  #Contient erreur à debugger
    esc_menu=True
    while esc_menu:
        menu_rect = pygame.draw.rect(screen, BLACK, (53,50,640,100))
        pygame.draw.rect(screen, LIGHTBLUE, (53,50,640,100),3) #menu2_rect
        menu_txt = bfont.render("ESCAPE MENU",True , LIGHTBLUE)
        screen.blit(menu_txt,(75,60))

        menu_rect = pygame.draw.rect(screen, BLACK, (110,210,530,100))
        pygame.draw.rect(screen, LIGHTBLUE, (110,210,530,100),3) #j2_rect
        j_txt = mfont.render("MENU PRINCIPAL",True ,LIGHTBLUE)
        screen.blit(j_txt,(125,235))

        cont_rect = pygame.draw.rect(screen, BLACK, (110,360,530,100))
        pygame.draw.rect(screen, LIGHTBLUE, (110,360,530,100),3) #cont2_rect
        cont_txt = mfont.render("CONTINUER",True ,LIGHTBLUE)
        screen.blit(cont_txt,(215,385))

        quit_rect = pygame.draw.rect(screen, BLACK, (110,510,530,100))
        pygame.draw.rect(screen, LIGHTBLUE, (110,510,530,100),3) #quit2_rect
        quit_txt = mfont.render("QUITTER",True ,LIGHTBLUE)
        screen.blit(quit_txt,(245,535))

        if menu_rect.collidepoint(pygame.mouse.get_pos()):
            pygame.draw.rect(screen, LIGHTPINK, (110,210,530,100), 3) #menu_rect2
            j_txt = mfont.render("MENU PRINCIPAL",True ,LIGHTPINK)
            screen.blit(j_txt,(125,235))

        if cont_rect.collidepoint(pygame.mouse.get_pos()):
            pygame.draw.rect(screen, LIGHTPINK, (110,360,530,100), 3) #cont2_rect
            cont_txt = mfont.render("CONTINUER",True ,LIGHTPINK)
            screen.blit(cont_txt,(215,385))

        if quit_rect.collidepoint(pygame.mouse.get_pos()):
            pygame.draw.rect(screen, LIGHTPINK, (110,510,530,100), 3) #quit2_rect
            quit_txt = mfont.render("QUITTER",True ,LIGHTPINK)
            screen.blit(quit_txt,(245,535))

        for event in pygame.event.get():
            
            if event.type == pygame.QUIT:
                pygame.quit()
            
            elif event.type == pygame.MOUSEBUTTONDOWN:
                
                if menu_rect.collidepoint(pygame.mouse.get_pos()):
                    selection_sfx.play()
                    
                    main_menu()
                    change_music(level)
                    
                    esc_menu=False
                
                if cont_rect.collidepoint(pygame.mouse.get_pos()): # PROBLÈME
                    selection_sfx.play()
                    
                    esc_menu=False
                
                if quit_rect.collidepoint(pygame.mouse.get_pos()):
                    selection_sfx.play()
                    
                    pygame.quit()
                    
            elif event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:
                    esc_menu=False
        pygame.display.update()
